Rows and Columns

In SpreadJS, each sheet area has several rows and columns. SpreadJS provides methods for you to customize the rows and columns.

Description
app.js
index.html
styles.css
Copy to CodeMine

Use the addRows, addColumns, deleteRows, deleteColumns, setRowCount and setColumnCount methods to change the number of rows or columns in each sheet area.

When calling the setRowCount and setColumnCount methods, you can choose which used range type to protect.

    sheet.setRowCount(20, GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.UsedRangeType.data);
    sheet.setColumnCount(20, GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.UsedRangeType.style);

Each of the following lines could be used to change the row count of the sheet's viewport area.

    sheet.setRowCount(20, GC.Spread.Sheets.SheetArea.viewport);
    sheet.addRows(5, 10, GC.Spread.Sheets.SheetArea.viewport);
    sheet.deleteRows(20, 10, GC.Spread.Sheets.SheetArea.viewport);

If a row or column's resizeable property is false, it cannot be resized by user operations, but you can change its height or width directly by using code.

    sheet.setRowResizable(1, false);
    sheet.setColumnResizable(1, true);

    sheet.setRowHeight(1, 20);
    sheet.setColumnWidth(1, 40);

Use the setRowVisible and setColumnVisible methods to specify whether a row or column is displayed.

    sheet.setRowVisible(1, false);
    sheet.setColumnVisible(1, true);

In the sheet's viewport area, when a row or column is automatically sized, its height or width will be determined by the content's length. Use the following code to set a row or column to auto fit:

    sheet.autoFitColumn(1);
    sheet.autoFitRow(1);

SpreadJS also provides many methods to get useful information about a sheet's row or column, as illustrated in these lines of code.

    var rowCount = sheet.getRowCount();
    var columnCount = sheet.getColumnCount();
    var cell = sheet.getCell(7, 7);
    var cells = sheet.getRange(2, 2, 7, 7);
    var rowHeight = sheet.getRowHeight(7);
    var columnWidth = sheet.getColumnWidth(7);
    ...

SpreadJS provides the resizeZeroIndicator method to control whether to display double or single gridlines in the row or column header when the row height or column width is 0. The parameter is a ResizeZeroIndicator enumeration value.

  • default: single gridline (same as normal)
  • enhanced: double gridline (default)
    sheet.setRowHeight(4, 0);
    sheet.setColumnWidth(2, 0);
    spread.resizeZeroIndicator(GC.Spread.Sheets.ResizeZeroIndicator.enhanced);
    // spread.resizeZeroIndicator(GC.Spread.Sheets.ResizeZeroIndicator.default);
Use the addRows, addColumns, deleteRows, deleteColumns, setRowCount and setColumnCount methods to change the number of rows or columns in each sheet area. When calling the setRowCount and setColumnCount methods, you can choose which used range type to protect. Each of the following lines could be used to change the row count of the sheet's viewport area. If a row or column's resizeable property is false, it cannot be resized by user operations, but you can change its height or width directly by using code. Use the setRowVisible and setColumnVisible methods to specify whether a row or column is displayed. In the sheet's viewport area, when a row or column is automatically sized, its height or width will be determined by the content's length. Use the following code to set a row or column to auto fit: SpreadJS also provides many methods to get useful information about a sheet's row or column, as illustrated in these lines of code. SpreadJS provides the resizeZeroIndicator method to control whether to display double or single gridlines in the row or column header when the row height or column width is 0. The parameter is a ResizeZeroIndicator enumeration value. default: single gridline (same as normal) enhanced: double gridline (default)
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss")); var spreadNS = GC.Spread.Sheets, sheet = spread.getSheet(0), SheetArea = spreadNS.SheetArea; sheet.suspendPaint(); sheet.setRowCount(2, SheetArea.colHeader); sheet.setRowCount(10, SheetArea.viewport); sheet.setColumnCount(2, SheetArea.rowHeader); sheet.setColumnCount(6, SheetArea.viewport); sheet.setRowHeight(4, 0); sheet.setColumnWidth(2, 0); spread.options.resizeZeroIndicator = spreadNS.ResizeZeroIndicator.enhanced; for (var rowIndex = 1; rowIndex <= 9; rowIndex++) { sheet.setText(rowIndex, 0, "Row"); sheet.setValue(rowIndex, 1, rowIndex); } for (var columnIndex = 1; columnIndex <= 5; columnIndex++) { sheet.setText(0, columnIndex, "Column"); sheet.setValue(1, columnIndex, columnIndex); } sheet.resumePaint(); _getElementById("resizeZeroIndicator").value=spread.options.resizeZeroIndicator; _getElementById("resizeZeroIndicator").addEventListener('change',function () { spread.options.resizeZeroIndicator = + this.value; }); /* * Add a row in viewport area. */ _getElementById("btnAddRow").addEventListener('click', function () { var sheet = spread.getActiveSheet(); if (sheet) { sheet.addRows(sheet.getRowCount(SheetArea.viewport), 1); } }); /* * Delete a row in viewport area. */ _getElementById("btnAddColumn").addEventListener('click', function () { var sheet = spread.getActiveSheet(); if (sheet) { sheet.addColumns(sheet.getColumnCount(SheetArea.viewport), 1); } }); /* * Add a column in viewport area. */ _getElementById("btnDeleteRow").addEventListener('click', function () { var sheet = spread.getActiveSheet(); if (sheet) { sheet.deleteRows(sheet.getRowCount(SheetArea.viewport) - 1, 1); } }); /* * Delete a column in viewport area. */ _getElementById("btnDeleteColumn").addEventListener('click', function () { var sheet = spread.getActiveSheet(); if (sheet) { sheet.deleteColumns(sheet.getColumnCount(SheetArea.viewport) - 1, 1); } }); /* * Show or hide the specified row. */ _getElementById("chkRowVisible").addEventListener('click', function () { var sheet = spread.getActiveSheet(); var rowIndex = parseInt(_getElementById("rowIndex").value); if (!isNaN(rowIndex)) { sheet.setRowVisible(rowIndex, this.checked); } }); /* * Auto fit or not fit the specified row. */ _getElementById("chkRowAutoFit").addEventListener('click', function () { var sheet = spread.getActiveSheet(); var rowIndex = parseInt(_getElementById("rowIndex").value); if (!isNaN(rowIndex)) { var checked = this.checked; if (checked) { sheet.autoFitRow(rowIndex); } } }); /* * Show or hide the specified column. */ _getElementById("chkColumnVisible").addEventListener('click', function () { var sheet = spread.getActiveSheet(); var columnIndex = parseInt(_getElementById("columnIndex").value); if (!isNaN(columnIndex)) { sheet.setColumnVisible(columnIndex, this.checked); } }); /* * Auto fit or not fit the specified column. */ _getElementById("chkColumnAutoFit").addEventListener('click', function () { var sheet = spread.getActiveSheet(); var columnIndex = parseInt(_getElementById("columnIndex").value); if (!isNaN(columnIndex)) { var checked = this.checked; if (checked) { sheet.autoFitColumn(columnIndex); } } }); }; function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"> </div> <div class="options-container"> <div class="options-row"> <label style="display: inline-block;">The following buttons add/remove rows/columns at the end of the sheet.</label> </div> <div class="option-row"> <input type="button" value="Add Row" id="btnAddRow" /> <input type="button" value="Delete Row" id="btnDeleteRow" /> </div> <div class="option-row"> <input type="button" value="Add Column" id="btnAddColumn" /> <input type="button" value="Delete Column" id="btnDeleteColumn" /> </div> <hr /> <div class="option-row"> <label for="rowIndex" style="display: inline-block;width: 100px">Row Index:</label> <input type="text" id="rowIndex"/> <br> <label for="rowIndex" style="padding-top: 6px">The index is zero based.</label> <div class="option-row"> <input type="checkbox" id="chkRowVisible" checked /> <label for="chkRowVisible">Row Visible</label> </div> <div class="option-row"> <input type="checkbox" id="chkRowAutoFit" /> <label for="chkRowAutoFit">Row AutoFit</label> </div> </div> <hr /> <div class="option-row"> <label for="columnIndex" style="display: inline-block;width: 100px">Column Index:</label> <input type="text" id="columnIndex" /> <br> <label for="columnIndex" style="padding-top: 6px">The index is zero based.</label> <div class="option-row"> <input type="checkbox" id="chkColumnVisible" checked /> <label for="chkColumnVisible">Column Visible</label> </div> <div class="option-row"> <input type="checkbox" id="chkColumnAutoFit" /> <label for="chkColumnAutoFit">Column AutoFit</label> </div> </div> <hr /> <div class="option-row"> <span>ResizeZeroIndicator:</span> <select id="resizeZeroIndicator"> <option value="0">Default</option> <option value="1">Enhanced</option> </select> </div> </div> </div> </body> </html>
input[type="text"] { width: 200px; } .colorLabel { background-color: #F4F8EB; width: 170px; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { margin-bottom: 6px; } input { display: inline-block; } input[type=button] { width: 110px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Use the addRows, addColumns, deleteRows, deleteColumns, setRowCount and setColumnCount methods to change the number of rows or columns in each sheet area.
When calling the setRowCount and setColumnCount methods, you can choose which used range type to protect.
Each of the following lines could be used to change the row count of the sheet's viewport area.
If a row or column's resizeable property is false, it cannot be resized by user operations, but you can change its height or width directly by using code.
Use the setRowVisible and setColumnVisible methods to specify whether a row or column is displayed.
In the sheet's viewport area, when a row or column is automatically sized, its height or width will be determined by the content's length. Use the following code to set a row or column to auto fit:
SpreadJS also provides many methods to get useful information about a sheet's row or column, as illustrated in these lines of code.
SpreadJS provides the resizeZeroIndicator method to control whether to display double or single gridlines in the row or column header when the row height or column width is 0. The parameter is a ResizeZeroIndicator enumeration value.
default: single gridline (same as normal)
enhanced: double gridline (default)
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const useState = React.useState, spreadNS = GC.Spread.Sheets,
SheetArea = spreadNS.SheetArea;
export function AppFunc() {
const [rowIndex, setRowIndex] = useState(0);
const [columnIndex, setColumnIndex] = useState(0);
const [spread, setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(2, SheetArea.colHeader);
sheet.setRowCount(10, SheetArea.viewport);
sheet.setColumnCount(2, SheetArea.rowHeader);
sheet.setColumnCount(6, SheetArea.viewport);
sheet.setRowHeight(4, 0);
sheet.setColumnWidth(2, 0);
spread.options.resizeZeroIndicator = spreadNS.ResizeZeroIndicator.enhanced;
for (let rowIndex = 1; rowIndex <= 9; rowIndex++) {
sheet.setText(rowIndex, 0, "Row");
sheet.setValue(rowIndex, 1, rowIndex);
}
for (let columnIndex = 1; columnIndex <= 5; columnIndex++) {
sheet.setText(0, columnIndex, "Column");
sheet.setValue(1, columnIndex, columnIndex);
}
sheet.resumePaint();
}
/*
* Add a row in viewport area.
*/
const addRow = () => {
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addRows(sheet.getRowCount(SheetArea.viewport), 1);
}
}
/*
* Delete a row in viewport area.
*/
const addColumn = () => {
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addColumns(sheet.getColumnCount(SheetArea.viewport), 1);
}
}
/*
* Add a column in viewport area.
*/
const deleteRow = () => {
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteRows(sheet.getRowCount(SheetArea.viewport) - 1, 1);
}
}
/*
* Delete a column in viewport area.
*/
const deleteColumn = () => {
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteColumns(sheet.getColumnCount(SheetArea.viewport) - 1, 1);
}
}
const _setRowIndex = ($event) => {
setRowIndex($event.target.value);
}
const _setColumnIndex = ($event) => {
setColumnIndex($event.target.value);
}
/*
* Show or hide the specified row.
*/
const checkRowVisible = ($event) => {
let sheet = spread.getActiveSheet();
if (!isNaN(rowIndex)) {
sheet.setRowVisible(+rowIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified row.
*/
const checkRowAutoFit = ($event) => {
let sheet = spread.getActiveSheet();
if (!isNaN(rowIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitRow(+rowIndex);
}
}
}
/*
* Show or hide the specified column.
*/
const checkColumnVisible = ($event) => {
let sheet = spread.getActiveSheet();
if (!isNaN(columnIndex)) {
sheet.setColumnVisible(+columnIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified column.
*/
const checkColumnAutoFit = ($event) => {
let sheet = spread.getActiveSheet();
if (!isNaN(columnIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitColumn(+columnIndex);
}
}
}
const setResizeZeroIndicator = ($event) => {
spread.options.resizeZeroIndicator = +$event.target.value;
spread.repaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addRow={() => addRow()}
deleteRow={() => deleteRow()}
addColumn={() => addColumn()}
deleteColumn={() => deleteColumn()}
setRowIndex={(e) => _setRowIndex(e)}
checkRowVisible={(e) => checkRowVisible(e)}
checkRowAutoFit={(e) => checkRowAutoFit(e)}
setColumnIndex={(e) => _setColumnIndex(e)}
checkColumnVisible={(e) => checkColumnVisible(e)}
checkColumnAutoFit={(e) => checkColumnAutoFit(e)}
setResizeZeroIndicator={(e) => setResizeZeroIndicator(e)}
></Panel>
</div>
);
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="text" value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}} />
);
}
function SelectInput(props) {
const [value, setValue] = useState(props.value);
function renderSelectOptions(options) {
let optionElems = [];
for (let i = 0; i < options.length; i++) {
optionElems.push(<option value={options[i].value}>{options[i].text}</option>);
}
return optionElems;
}
return (
<select
id={props.id}
className={props.className}
value={value}
name={props.name}
onChange={(e) => {
setValue(e.target.value);
props.onChange(e);
}}
>
{renderSelectOptions(props.options)}
</select>
);
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function Panel(props) {
let selectOptions = [
{
value: 0,
text: "Default"
}, {
value: 1,
text: "Enhanced"
}
];
return (
<div className="options-container">
<div class="options-row">
<label>The following buttons add/remove rows/columns at the end of the sheet.</label>
</div>
<div className="options-row">
<input type="button" value="Add Row" onClick={props.addRow} />
<input type="button" value="Delete Row" onClick={props.deleteRow} />
</div>
<div className="options-row">
<input type="button" value="Add Column" onClick={props.addColumn} />
<input type="button" value="Delete Column" onClick={props.deleteColumn} />
</div>
<hr />
<div className="options-row">
<label htmlFor="rowIndex">Row Index:</label>
<TextInput id="rowIndex" value="" onChange={props.setRowIndex}></TextInput>
<label htmlFor="rowIndex" style={{ display: "block" }}>The index is zero based.</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkRowVisible" checked={true} onChange={props.checkRowVisible}></CheckBoxInput>
<label htmlFor="checkRowVisible">Row Visible</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkRowAutoFit" checked={false} onChange={props.checkRowAutoFit}></CheckBoxInput>
<label htmlFor="checkRowAutoFit">Row AutoFit</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="columnIndex">Column Index:</label>
<TextInput id="columnIndex" value="" onChange={props.setColumnIndex}></TextInput>
<label htmlFor="columnIndex" style={{ display: "block" }}>The index is zero based.</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkColumnVisible" checked={true}
onChange={props.checkColumnVisible}></CheckBoxInput>
<label htmlFor="checkColumnVisible">Column Visible</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkColumnAutoFit" checked={false}
onChange={props.checkColumnAutoFit}></CheckBoxInput>
<label htmlFor="checkColumnAutoFit">Column AutoFit</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="resizeZeroIndicator">ResizeZeroIndicator:</label>
<SelectInput id="resizeZeroIndicator" value={1} onChange={props.setResizeZeroIndicator}
options={selectOptions}></SelectInput>
</div>
</div>
);
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const Component = React.Component, useState = React.useState, spreadNS = GC.Spread.Sheets,
SheetArea = spreadNS.SheetArea;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
initSpread(spread) {
this.spread = spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(2, SheetArea.colHeader);
sheet.setRowCount(10, SheetArea.viewport);
sheet.setColumnCount(2, SheetArea.rowHeader);
sheet.setColumnCount(6, SheetArea.viewport);
sheet.setRowHeight(4, 0);
sheet.setColumnWidth(2, 0);
spread.options.resizeZeroIndicator = spreadNS.ResizeZeroIndicator.enhanced;
for (let rowIndex = 1; rowIndex <= 9; rowIndex++) {
sheet.setText(rowIndex, 0, "Row");
sheet.setValue(rowIndex, 1, rowIndex);
}
for (let columnIndex = 1; columnIndex <= 5; columnIndex++) {
sheet.setText(0, columnIndex, "Column");
sheet.setValue(1, columnIndex, columnIndex);
}
sheet.resumePaint();
}
/*
* Add a row in viewport area.
*/
addRow() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addRows(sheet.getRowCount(SheetArea.viewport), 1);
}
}
/*
* Delete a row in viewport area.
*/
addColumn() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addColumns(sheet.getColumnCount(SheetArea.viewport), 1);
}
}
/*
* Add a column in viewport area.
*/
deleteRow() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteRows(sheet.getRowCount(SheetArea.viewport) - 1, 1);
}
}
/*
* Delete a column in viewport area.
*/
deleteColumn() {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteColumns(sheet.getColumnCount(SheetArea.viewport) - 1, 1);
}
}
setRowIndex($event) {
this.rowIndex = $event.target.value;
}
setColumnIndex($event) {
this.columnIndex = $event.target.value;
}
/*
* Show or hide the specified row.
*/
checkRowVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let rowIndex = parseInt(this.rowIndex);
if (!isNaN(rowIndex)) {
sheet.setRowVisible(rowIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified row.
*/
checkRowAutoFit($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let rowIndex = parseInt(this.rowIndex);
if (!isNaN(rowIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitRow(rowIndex);
}
}
}
/*
* Show or hide the specified column.
*/
checkColumnVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let columnIndex = parseInt(this.columnIndex);
if (!isNaN(columnIndex)) {
sheet.setColumnVisible(columnIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified column.
*/
checkColumnAutoFit($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let columnIndex = parseInt(this.columnIndex);
if (!isNaN(columnIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitColumn(columnIndex);
}
}
}
setResizeZeroIndicator($event) {
let spread = this.spread;
spread.options.resizeZeroIndicator = +$event.target.value;
spread.repaint();
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addRow={() => this.addRow()}
deleteRow={() => this.deleteRow()}
addColumn={() => this.addColumn()}
deleteColumn={() => this.deleteColumn()}
setRowIndex={(e) => this.setRowIndex(e)}
checkRowVisible={(e) => this.checkRowVisible(e)}
checkRowAutoFit={(e) => this.checkRowAutoFit(e)}
setColumnIndex={(e) => this.setColumnIndex(e)}
checkColumnVisible={(e) => this.checkColumnVisible(e)}
checkColumnAutoFit={(e) => this.checkColumnAutoFit(e)}
setResizeZeroIndicator={(e) => this.setResizeZeroIndicator(e)}
></Panel>
</div>
);
}
}
function TextInput(props) {
const [value, setValue] = useState(props.value);
return (
<input type="text" value={value} onChange={(e) => {
setValue(e.target.value);
props.onChange(e)
}} />
);
}
function SelectInput(props) {
const [value, setValue] = useState(props.value);
function renderSelectOptions(options) {
let optionElems = [];
for (let i = 0; i < options.length; i++) {
optionElems.push(<option value={options[i].value}>{options[i].text}</option>);
}
return optionElems;
}
return (
<select
id={props.id}
className={props.className}
value={value}
name={props.name}
onChange={(e) => {
setValue(e.target.value);
props.onChange(e);
}}
>
{renderSelectOptions(props.options)}
</select>
);
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function Panel(props) {
let selectOptions = [
{
value: 0,
text: "Default"
}, {
value: 1,
text: "Enhanced"
}
];
return (
<div className="options-container">
<div class="options-row">
<label>The following buttons add/remove rows/columns at the end of the sheet.</label>
</div>
<div className="options-row">
<input type="button" value="Add Row" onClick={props.addRow} />
<input type="button" value="Delete Row" onClick={props.deleteRow} />
</div>
<div className="options-row">
<input type="button" value="Add Column" onClick={props.addColumn} />
<input type="button" value="Delete Column" onClick={props.deleteColumn} />
</div>
<hr />
<div className="options-row">
<label htmlFor="rowIndex">Row Index:</label>
<TextInput id="rowIndex" value="" onChange={props.setRowIndex}></TextInput>
<label htmlFor="rowIndex" style={{ display: "block" }}>The index is zero based.</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkRowVisible" checked={true} onChange={props.checkRowVisible}></CheckBoxInput>
<label htmlFor="checkRowVisible">Row Visible</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkRowAutoFit" checked={false} onChange={props.checkRowAutoFit}></CheckBoxInput>
<label htmlFor="checkRowAutoFit">Row AutoFit</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="columnIndex">Column Index:</label>
<TextInput id="columnIndex" value="" onChange={props.setColumnIndex}></TextInput>
<label htmlFor="columnIndex" style={{ display: "block" }}>The index is zero based.</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkColumnVisible" checked={true}
onChange={props.checkColumnVisible}></CheckBoxInput>
<label htmlFor="checkColumnVisible">Column Visible</label>
</div>
<div className="options-row">
<CheckBoxInput id="checkColumnAutoFit" checked={false}
onChange={props.checkColumnAutoFit}></CheckBoxInput>
<label htmlFor="checkColumnAutoFit">Column AutoFit</label>
</div>
<hr />
<div className="options-row">
<label htmlFor="resizeZeroIndicator">ResizeZeroIndicator:</label>
<SelectInput id="resizeZeroIndicator" value={1} onChange={props.setResizeZeroIndicator}
options={selectOptions}></SelectInput>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
input[type=button] {
width: 110px;
display: inline-block;
}
label {
margin-bottom: 6px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Use the addRows, addColumns, deleteRows, deleteColumns, setRowCount and setColumnCount methods to change the number of rows or columns in each sheet area.
When calling the setRowCount and setColumnCount methods, you can choose which used range type to protect.
Each of the following lines could be used to change the row count of the sheet's viewport area.
If a row or column's resizeable property is false, it cannot be resized by user operations, but you can change its height or width directly by using code.
Use the setRowVisible and setColumnVisible methods to specify whether a row or column is displayed.
In the sheet's viewport area, when a row or column is automatically sized, its height or width will be determined by the content's length. Use the following code to set a row or column to auto fit:
SpreadJS also provides many methods to get useful information about a sheet's row or column, as illustrated in these lines of code.
SpreadJS provides the resizeZeroIndicator method to control whether to display double or single gridlines in the row or column header when the row height or column width is 0. The parameter is a ResizeZeroIndicator enumeration value.
default: single gridline (same as normal)
enhanced: double gridline (default)
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<label style="display: inline-block;">The following buttons add/remove rows/columns at the end of the
sheet.</label>
</div>
<div class="options-row">
<input type="button" value="Add Row" id="btnAddRow" @click="addRow()" />
<input type="button" value="Delete Row" id="btnDeleteRow" @click="deleteRow()" />
</div>
<div class="options-row">
<input type="button" value="Add Column" id="btnAddColumn" @click="addColumn()" />
<input type="button" value="Delete Column" id="btnDeleteColumn" @click="deleteColumn()" />
</div>
<hr />
<div class="options-row">
<label for="rowIndex" style="display: inline-block;width: 100px">Row Index:</label>
<input type="text" id="rowIndex" v-model="rowIndex" />
<br>
<label for="rowIndex" style="padding-top: 6px">The index is zero based.</label>
<div class="options-row">
<input type="checkbox" id="chkRowVisible" v-model="checkRowVisble" />
<label for="chkRowVisible">Row Visible</label>
</div>
<div class="options-row">
<input type="checkbox" id="chkRowAutoFit" v-model="checkRowAutoFit" />
<label for="chkRowAutoFit">Row AutoFit</label>
</div>
</div>
<hr />
<div class="options-row">
<label for="columnIndex" style="display: inline-block;width: 100px">Column Index:</label>
<input type="text" id="columnIndex" v-model="columnIndex" />
<br>
<label for="columnIndex" style="padding-top: 6px">The index is zero based.</label>
<div class="options-row">
<input type="checkbox" id="chkColumnVisible" v-model="checkColumnVisible" />
<label for="chkColumnVisible">Column Visible</label>
</div>
<div class="options-row">
<input type="checkbox" id="chkColumnAutoFit" v-model="checkColumnAutoFit" />
<label for="chkColumnAutoFit">Column AutoFit</label>
</div>
</div>
<hr />
<div class="options-row">
<span>ResizeZeroIndicator:</span>
<select id="resizeZeroIndicator" v-model="setResizeZeroIndicator">
<option value="0">Default</option>
<option value="1" selected>Enhanced</option>
</select>
</div>
</div>
</div>
</template>
<script setup>
import GC from '@mescius/spread-sheets';
import { ref, watch } from "vue";
import "@mescius/spread-sheets-vue";
let spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
let mySpread;
const rowIndex = ref("");
const columnIndex = ref("");
const checkRowVisble = ref(true);
const checkRowAutoFit = ref(false);
const checkColumnVisible = ref(true);
const checkColumnAutoFit = ref(false);
const setResizeZeroIndicator = ref(1);
let initSpread = function (spread) {
mySpread = spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(2, SheetArea.colHeader);
sheet.setRowCount(10, SheetArea.viewport);
sheet.setColumnCount(2, SheetArea.rowHeader);
sheet.setColumnCount(6, SheetArea.viewport);
sheet.setRowHeight(4, 0);
sheet.setColumnWidth(2, 0);
spread.options.resizeZeroIndicator = spreadNS.ResizeZeroIndicator.enhanced;
for (var rowIndex = 1; rowIndex <= 9; rowIndex++) {
sheet.setText(rowIndex, 0, "Row");
sheet.setValue(rowIndex, 1, rowIndex);
}
for (var columnIndex = 1; columnIndex <= 5; columnIndex++) {
sheet.setText(0, columnIndex, "Column");
sheet.setValue(1, columnIndex, columnIndex);
}
sheet.resumePaint();
}
let addRow = () => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addRows(sheet.getRowCount(SheetArea.viewport), 1);
}
}
let addColumn = () => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addColumns(sheet.getColumnCount(SheetArea.viewport), 1);
}
}
let deleteRow = () => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteRows(sheet.getRowCount(SheetArea.viewport) - 1, 1);
}
}
let deleteColumn = () => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteColumns(sheet.getColumnCount(SheetArea.viewport) - 1, 1);
}
}
watch(rowIndex, (value) => {
rowIndex.value = value;
});
watch(columnIndex, (value) => {
columnIndex.value = value;
});
watch(checkRowVisble, (value) => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
let rowIndexValue = parseInt(rowIndex.value);
if (!isNaN(rowIndexValue)) {
sheet.setRowVisible(rowIndexValue, value);
}
});
watch(checkRowAutoFit, (value) => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
let rowIndexValue = parseInt(rowIndex.value);
if (!isNaN(rowIndexValue)) {
let checked = value;
if (checked) {
sheet.autoFitRow(rowIndexValue);
}
}
});
watch(checkColumnVisible, (value) => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
let columnIndexValue = parseInt(columnIndex.value);
if (!isNaN(columnIndexValue)) {
sheet.setColumnVisible(columnIndexValue, value);
}
});
watch(checkColumnAutoFit, (value) => {
let spread = mySpread;
let sheet = spread.getActiveSheet();
let columnIndexValue = parseInt(columnIndex.value);
if (!isNaN(columnIndexValue)) {
let checked = value;
if (checked) {
sheet.autoFitColumn(columnIndexValue);
}
}
});
watch(setResizeZeroIndicator, (value) => {
let spread = mySpread;
spread.options.resizeZeroIndicator = +value;
spread.repaint();
});
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
display: inline-block;
width: 110px;
}
input[type="text"] {
width: 200px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Use the addRows, addColumns, deleteRows, deleteColumns, setRowCount and setColumnCount methods to change the number of rows or columns in each sheet area.
When calling the setRowCount and setColumnCount methods, you can choose which used range type to protect.
Each of the following lines could be used to change the row count of the sheet's viewport area.
If a row or column's resizeable property is false, it cannot be resized by user operations, but you can change its height or width directly by using code.
Use the setRowVisible and setColumnVisible methods to specify whether a row or column is displayed.
In the sheet's viewport area, when a row or column is automatically sized, its height or width will be determined by the content's length. Use the following code to set a row or column to auto fit:
SpreadJS also provides many methods to get useful information about a sheet's row or column, as illustrated in these lines of code.
SpreadJS provides the resizeZeroIndicator method to control whether to display double or single gridlines in the row or column header when the row height or column width is 0. The parameter is a ResizeZeroIndicator enumeration value.
default: single gridline (same as normal)
enhanced: double gridline (default)
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
rowIndex: string;
columnIndex: string;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.rowIndex = '';
this.columnIndex = '';
}
initSpread($event: any) {
let spread = this.spread = $event.spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setRowCount(2, SheetArea.colHeader);
sheet.setRowCount(10, SheetArea.viewport);
sheet.setColumnCount(2, SheetArea.rowHeader);
sheet.setColumnCount(6, SheetArea.viewport);
sheet.setRowHeight(4, 0);
sheet.setColumnWidth(2, 0);
spread.options.resizeZeroIndicator = spreadNS.ResizeZeroIndicator.enhanced;
for (var rowIndex = 1; rowIndex <= 9; rowIndex++) {
sheet.setText(rowIndex, 0, "Row");
sheet.setValue(rowIndex, 1, rowIndex);
}
for (var columnIndex = 1; columnIndex <= 5; columnIndex++) {
sheet.setText(0, columnIndex, "Column");
sheet.setValue(1, columnIndex, columnIndex);
}
sheet.resumePaint();
}
/*
* Add a row in viewport area.
*/
addRow () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addRows(sheet.getRowCount(SheetArea.viewport), 1);
}
}
/*
* Delete a row in viewport area.
*/
addColumn () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.addColumns(sheet.getColumnCount(SheetArea.viewport), 1);
}
}
/*
* Add a column in viewport area.
*/
deleteRow () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteRows(sheet.getRowCount(SheetArea.viewport) - 1, 1);
}
}
/*
* Delete a column in viewport area.
*/
deleteColumn () {
let spread = this.spread;
let sheet = spread.getActiveSheet();
if (sheet) {
sheet.deleteColumns(sheet.getColumnCount(SheetArea.viewport) - 1, 1);
}
}
setRowIndex ($event) {
this.rowIndex = $event.target.value;
}
setColumnIndex ($event) {
this.columnIndex = $event.target.value;
}
/*
* Show or hide the specified row.
*/
checkRowVisble ($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let rowIndex = parseInt(this.rowIndex);
if (!isNaN(rowIndex)) {
sheet.setRowVisible(rowIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified row.
*/
checkRowAutoFit ($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let rowIndex = parseInt(this.rowIndex);
if (!isNaN(rowIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitRow(rowIndex);
}
}
}
/*
* Show or hide the specified column.
*/
checkColumnVisible ($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let columnIndex = parseInt(this.columnIndex);
if (!isNaN(columnIndex)) {
sheet.setColumnVisible(columnIndex, $event.target.checked);
}
}
/*
* Auto fit or not fit the specified column.
*/
checkColumnAutoFit ($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let columnIndex = parseInt(this.columnIndex);
if (!isNaN(columnIndex)) {
let checked = $event.target.checked;
if (checked) {
sheet.autoFitColumn(columnIndex);
}
}
}
setResizeZeroIndicator ($event) {
let spread = this.spread;
spread.options.resizeZeroIndicator = + $event.target.value;
spread.repaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<label style="display: inline-block;">The following buttons add/remove rows/columns at the end of the sheet.</label>
</div>
<div class="options-row">
<input type="button" value="Add Row" id="btnAddRow" (click)="addRow()" />
<input type="button" value="Delete Row" id="btnDeleteRow" (click)="deleteRow()" />
</div>
<div class="options-row">
<input type="button" value="Add Column" id="btnAddColumn" (click)="addColumn()" />
<input type="button" value="Delete Column" id="btnDeleteColumn" (click)="deleteColumn()" />
</div>
<hr />
<div class="options-row">
<label for="rowIndex" style="display: inline-block;width: 100px">Row Index:</label>
<input type="text" id="rowIndex" [value]="rowIndex" (change)="setRowIndex($event)"/>
<br>
<label for="rowIndex" style="padding-top: 6px">The index is zero based.</label>
<div class="options-row">
<input type="checkbox" id="chkRowVisible" checked (change)="checkRowVisble($event)" />
<label for="chkRowVisible">Row Visible</label>
</div>
<div class="options-row">
<input type="checkbox" id="chkRowAutoFit" (change)="checkRowAutoFit($event)" />
<label for="chkRowAutoFit">Row AutoFit</label>
</div>
</div>
<hr />
<div class="options-row">
<label for="columnIndex" style="display: inline-block;width: 100px">Column Index:</label>
<input type="text" id="columnIndex" [value]="columnIndex" (change)="setColumnIndex($event)" />
<br>
<label for="columnIndex" style="padding-top: 6px">The index is zero based.</label>
<div class="options-row">
<input type="checkbox" id="chkColumnVisible" checked (change)="checkColumnVisible($event)"/>
<label for="chkColumnVisible">Column Visible</label>
</div>
<div class="options-row">
<input type="checkbox" id="chkColumnAutoFit" (change)="checkColumnAutoFit($event)"/>
<label for="chkColumnAutoFit">Column AutoFit</label>
</div>
</div>
<hr />
<div class="options-row">
<span>ResizeZeroIndicator:</span>
<select id="resizeZeroIndicator" (change)="setResizeZeroIndicator($event)">
<option value="0">Default</option>
<option value="1" selected>Enhanced</option>
</select>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
}
input[type=button] {
width: 110px;
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);